#include <bits/stdc++.h>

using namespace std;

typedef long double ld;
typedef long long ll;

const int M = 501;
const ll INF = M * M * (ll)(1e9);
const ll p1 = 31;
const ll M1 = 1e9 + 7;
const ll p2 = 239;
const ll M2 = 1e9 + 9;
const int N = 1e5 + 1;

pair<ll, int> cost[M][M], cc[M][M];
int good[M][M];
map<pair<int, ll>, pair<int, int> > w;
ll dp[M][M], pr1[M], pr2[M], st1[M], st2[M];
vector<vector<int> > v(M);
vector<vector<char> > vv(M);
int n, m, t, gl[M], len[N], up[M];
vector<int> pr;

ll gett(int s, int f)
{
    return cc[s][f].first;
}

void dfs(int p)
{
    pr.push_back(p);
    for (int i : v[p])
        dfs(i);
    for (int s : pr)
    {
        dp[p][s] = INF;
        ll dn = 0;
        for (int i : v[p])
            dn += dp[i][p];
        ll delta = INF;
        int it = 0;
        int tt = 0;
        for (int i : v[p])
        {
            if (delta > dp[i][s] - dp[i][p])
            {
                delta = dp[i][s] - dp[i][p];
                tt = it;
            }
            it++;
        }
        dp[p][s] = min(dp[p][s], delta + dn);
        good[p][s] = -tt - 1;
        if (gett(p, s) + dn < dp[p][s])
        {
            dp[p][s] = gett(p, s) + dn;
            good[p][s] = cc[p][s].second;
        }
    }
    pr.pop_back();
}

void dfs_help(int p, int d)
{
    gl[p] = d;
    if (d == 0)
    {
        pr1[p] = 0;
        pr2[p] = 0;
    }
    int it = 0;
    for (int i : v[p])
    {
        char x = vv[p][it];
        pr1[i] = (pr1[p] * p1 + (x - 'a' + 1)) % M1;
        pr2[i] = (pr2[p] * p2 + (x - 'a' + 1)) % M2;
        dfs_help(i, d + 1);
        it++;
    }
}

pair<int, ll> getway(int s, int f)
{
    int len = gl[s] - gl[f];
    ll h1 = (pr1[s] - st1[len] * pr1[f]) % M1;
    if (h1 < 0) h1 += M1;
    ll h2 = (pr2[s] - st2[len] * pr2[f]) % M2;
    if (h2 < 0) h2 += M2;
    return make_pair(len, (h1 << 32LL) | h2);
}

void dfs_help2(int p)
{
    if (!pr.empty())
        up[p] = pr.back();
    //cerr << p << "\n";
    pr.push_back(p);
    for (int it = 0; it < pr.size(); it++)
    {
        int i = pr[it];
        if (i == p)
        {
            cost[p][p] = make_pair(0, 0);
            cc[p][p] = make_pair(0, 0);
        }
        else
        {
            pair<int, ll> hs = getway(p, i);
            if (w.find(hs) == w.end())
            {
                cost[p][i] = make_pair(INF, 0);
                cc[p][i] = make_pair(INF, 0);
                if (it != 0)
                    cc[p][i] = cc[p][pr[it - 1]];
            }
            else
            {
                cost[p][i] = w[hs];
                cc[p][i] = cost[p][i];
                if (it != 0)
                    cc[p][i] = min(cc[p][i], cc[p][pr[it - 1]]);
            }
        }
    }
    for (int i : v[p])
        dfs_help2(i);
    pr.pop_back();
}

vector<tuple<int, int, int> > qq;

void run(int s, int f)
{
    //cerr << s << " " << f << "\n";
    if (good[s][f] >= 0)
    {
        qq.push_back(make_tuple(f, s, good[s][f]));
        for (int i : v[s])
            run(i, s);
        return;
    }
    int to = -good[s][f] - 1;
    int it = 0;
    for (int i : v[s])
    {
        if (it == to)
            run(i, f);
        else
            run(i, s);
        it++;
    }
}

int upper(int s, int to)
{
    for (int i = 0; i < to; i++)
        s = up[s];
    return s;
}

int main()
{   /*
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout); /**/
    cin.sync_with_stdio(0);
    st1[0] = 1;
    st2[0] = 1;
    for (int i = 1; i < M; i++)
    {
        st1[i] = (st1[i - 1] * p1) % M1;
        st2[i] = (st2[i - 1] * p2) % M2;
    }
    cin >> n >> m >> t;
    for (int i = 1; i < n; i++)
    {
        int p;
        char x;
        cin >> p >> x;
        p--;
        v[p].push_back(i);
        vv[p].push_back(x);
    }
    for (int i = 0; i < m; i++)
    {
        string s;
        int c;
        cin >> c >> s;
        len[i] = s.size();
        ll h1 = 0;
        for (char x : s)
            h1 = (h1 * p1 + (x - 'a' + 1)) % M1;
        ll h2 = 0;
        for (char x : s)
            h2 = (h2 * p2 + (x - 'a' + 1)) % M2;
        ll h = (h1 << 32LL) | h2;
        if (w.find(make_pair(s.size(), h)) == w.end())
            w[make_pair(s.size(), h)] = make_pair(c, i);
        else
            w[make_pair(s.size(), h)] = min(w[make_pair(s.size(), h)], make_pair(c, i));
    }
    dfs_help(0, 0);
    dfs_help2(0);
    dfs(0);
    if (dp[0][0] >= INF)
    {
        cout << -1;
        return 0;
    }
    cout << dp[0][0] << "\n";
    if (t == 0)
        return 0;
    run(0, 0);
    cout << qq.size() << "\n";
    for (tuple<int, int, int> t : qq)
    {
        int to = get<1>(t);
        cout << upper(to, len[get<2>(t)]) + 1 << " " << get<1>(t) + 1 << " " << get<2>(t) + 1 << "\n";
    }
    return 0;
}
