#include <bits/stdc++.h>

using namespace std;

typedef long double ld;
typedef long long ll;

const int M = 1e5 + 1;
const ll INF = 1e18;
const int N = 1e5 + 1;
const int BIG = 2 * 1e9;

int k, m, n;
int c[M], pr[M], v[M];

int num(int i)
{
    int l = 0;
    int r = n;
    while (r - l > 1)
    {
        int h = (l + r) >> 1;
        if (i < pr[h])
            r = h;
        else
            l = h;
    }
    return r - 1;
}

map<int, int> run(int l, int r)
{
    int c = num(l);
    if (c == num(r - 1))
    {
        c = v[c];
        map<int, int> dp;
        dp[-1] = 1;
        dp[c] = 0;
        return dp;
    }
    int mid = (l + r) >> 1;
    map<int, int> dp1 = run(l, mid);
    map<int, int> dp2 = run(mid, r);
    map<int, int> dp;
    for (pair<int, int> t : dp1)
    {
        if (dp2.find(t.first) == dp2.end())
            dp[t.first] = dp1[t.first] + dp2[-1];
        else
            dp[t.first] = dp1[t.first] + dp2[t.first];
    }
    for (pair<int, int> t : dp2)
    {
        if (dp1.find(t.first) == dp1.end())
            dp[t.first] = dp1[-1] + dp2[t.first];
    }
    int ans = BIG;
    for (pair<int, int> t : dp)
        ans = min(ans, t.second);
    for (pair<int, int> t : dp)
        dp[t.first] = min(dp[t.first], ans + 1);
    //cerr << l << " " << r << "\n";
    //for (pair<int, int> t : dp)
    //    cerr << "!" << t.first << " " << t.second << "\n";
    return dp;
}

int main()
{   /*
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> k >> n >> m;
    for (int i = 0; i < n; i++)
        cin >> c[i] >> v[i];
    pr[0] = 0;
    for (int i = 0; i < n; i++)
        pr[i + 1] = pr[i] + c[i];
    map<int, int> dp = run(0, (1 << k));
    int ans = (1 << k);
    for (pair<int, int> t : dp)
        ans = min(ans, t.second + (t.first != -1));
    /*for (pair<int, int> t : dp)
        if (t.second == ans)
            cerr << t.first << "!\n";*/
    cout << ans;
    return 0;
}
